#include "frac.h"
#include <math.h>
#include <stdio.h>
#include <stdlib.h>

frac_t *frac_init(int no, int de) {

  frac_t *f = malloc(sizeof(frac_t));

  // printf("%ld \n\n\n\n\n",sizeof(frac_t));

  f->n = no;
  if (de == 0) {
    printf("denominator can't be 0, set to 1 \n");
    f->d = 1;
  } else {
    f->d = de;
  }

  return f;
}

void clearFrac(frac_t *address) { free(address); }

void printFrac(frac_t *a) { printf("%d/%d \n", a->n, a->d); }

int PGCD(int a, int b) {

  // int n=a;
  // int m=b;

  while (a % b > 0) {
    int tmp = a;
    a = b;
    b = tmp % b;
  }
  //  printf("Le pgcd de %d et %d est %d \n",n,m,b);

  return b;
}

void reduc(frac_t *a) {

  int div = PGCD(a->n, a->d);
  a->n /= div;
  a->d /= div;
}

frac_t *powFrac(frac_t *a, int p) {

  a->n = pow(a->n, p);
  a->d = pow(a->d, p);

  return a;
}

frac_t *add(frac_t *a, frac_t *b) {

  frac_t *f = malloc(sizeof(frac_t));

  f->n = a->n * b->d + b->n * a->d;
  f->d = a->d * b->d;

  // printf("before reduc %d %d",f->n,f->d);
  reduc(f);
  // printf("after reduc %d %d",f->n,f->d);
  return f;
}

frac_t *sub(frac_t *a, frac_t *b) {

  frac_t *f = malloc(sizeof(frac_t));

  f->n = a->n * b->d - b->n * a->d;

  f->d = a->d * b->d;
  // printf("before reduc %d %d\n",f->n,f->d);
  reduc(f);

  return f;
}

frac_t *mult(frac_t *a, frac_t *b) {

  frac_t *f = malloc(sizeof(frac_t));

  f->n = a->n * b->n;
  f->d = a->d * b->d;

  reduc(f);
  return f;
}

frac_t *divFrac(frac_t *a, frac_t *b) {

  frac_t *f = malloc(sizeof(frac_t));

  f->n = a->n * b->d;
  f->d = a->d * b->n;

  reduc(f);
  return f;
}

// frac_t neg(frac_t a){

//     a.n*=-1;
//     return a;
// }

double *toDouble(frac_t *a) {
  double *dbl = malloc(sizeof(double));

  *dbl = a->n / (a->d * 1.0);
  printf("%f\n", *dbl);
  return dbl;
}

void add2(frac_t *a, frac_t *b) {

  frac_t *f = malloc(sizeof(frac_t));

  f->n = a->n * b->d + b->n * a->d;

  f->d = a->d * b->d;

  a->n = f->n;
  a->d = f->d;

  free(f);
  // printf("before reduc %d %d",f->n,f->d);
  // reduc(f);
  // printf("after reduc %d %d",f->n,f->d);
}

void PI() {
  frac_t *pi = frac_init(1, 1);
  frac_t *f;

  for (int i = 2; i < 6; i++) {

    f = frac_init(1, pow(i, 4));
    frac_t *tmp=add(pi, f);
    pi->n=tmp->n;
    pi->d=tmp->d;
    clearFrac(tmp);
    clearFrac(f);
    
  }
    printFrac(pi);


  clearFrac(pi);
  // clearFrac(f);
}
